# NPM Module Seed

## Get Started

1. clone this project to your local machine:

```bash
$ git clone http://gitgogs.railinc.com:3000/railinc-ui/npm-component-seed.git
```
2. Open package.json and change "prepublish" key to "xprepublish"
   * Do this to avoid a tsc call, which will fail step 3 until your comopnent is valid

3. Run npm install:

```bash
$ npm install
```

4. Reset the key "xprepublish" to "prepublish"
5. Begin coding your component

## Customize Your Package
1. Name your module
2. Set your module version
3. Set your repository url
4. Set your main file (the bundled file)
5. Set your module entry point
6. Define any dependencies you need for your module to execute

## Customize Your rollup.config.js File
This will create a UMD file of your module: [What is UMD and why is it important](https://github.com/umdjs/umd)
1. Set your file name (dest)
2. Set your module name (moduleName)

## Folder Structure
* index.ts
   * src/
      * rl-your.component.ts 
      * rl-your.service.ts
      * rl-your.directive.ts

This could structure could be as deep as neccessary, depending on the complexity of your reusable module.
Follow the [Angular convention](https://angular.io/guide/styleguide#feature-modules) for module/component structure

## Testing
To best test your module... 

MIT © [Derek Carter](mailto:derek.carter@railinc.com)
