import { RlDatePickerInputComponent } from './datepicker-input.component';
import { Component, ElementRef, Input, Output, EventEmitter } from '@angular/core';
import { NgControl } from '@angular/forms';
var RlDatePickerPopupComponent = (function (_super) {
    __extends(RlDatePickerPopupComponent, _super);
    function RlDatePickerPopupComponent(el, control) {
        var _this = _super.call(this, el, control) || this;
        _this.opened = false;
        _this.onClose = new EventEmitter();
        _this.onDateChange = new EventEmitter();
        _this.ngOnDestroy = function () {
            _this.removeEventListener();
            _this.onClose.unsubscribe();
            _this.onDateChange.unsubscribe();
        };
        return _this;
    }
    RlDatePickerPopupComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.control.valueChanges.subscribe(function (value) {
            _this.onDateChange.emit(value);
        });
    };
    RlDatePickerPopupComponent.prototype.ngDoCheck = function () {
        var _this = this;
        _super.prototype.ngDoCheck.call(this);
        if (!this.opened && this.subscriber && !this.subscriber.closed) {
            setTimeout(function () {
                _this.removeEventListener();
                _this.onClose.emit();
            }, 0);
        }
        else if (this.opened && (!this.subscriber || (this.subscriber && this.subscriber.closed))) {
            this.addEventListener();
        }
    };
    Object.defineProperty(RlDatePickerPopupComponent.prototype, "DatepickerElement", {
        get: function () {
            return this.LayoutElement.children[0];
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], RlDatePickerPopupComponent.prototype, "opened", void 0);
    __decorate([
        Input(),
        __metadata("design:type", ElementRef)
    ], RlDatePickerPopupComponent.prototype, "OpenBtn", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], RlDatePickerPopupComponent.prototype, "onClose", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], RlDatePickerPopupComponent.prototype, "onDateChange", void 0);
    RlDatePickerPopupComponent = __decorate([
        Component({
            selector: 'rl-datepicker-popup',
            template: "\n    <div rlDatepickerPopup>\n        <datepicker [(ngModel)]=\"dateObject\" name=\"datepicker\" [hidden]=\"!opened\" [minDate]=\"options.minDate\" [maxDate]=\"options.maxDate\" [showWeeks]=\"options.showWeeks\" (selectionDone)=\"opened = false\"></datepicker>\n            \n        <div [hidden]=\"!opened\" style=\"padding: 5px;\">\n            <span class=\"btn-group pull-left\">       \n                <button type=\"button\" class=\"btn btn-sm btn-info\" (click)=\"setToToday()\">Today</button>\n                <button type=\"button\" class=\"btn btn-sm btn-danger\" (click)=\"clearDate()\">Clear</button>\n            </span>\n            <button type=\"button\" class=\"btn btn-sm btn-success pull-right\" (click)=\"opened = false\">Done</button>\n        </div>\n    </div>\n  "
        }),
        __metadata("design:paramtypes", [ElementRef, NgControl])
    ], RlDatePickerPopupComponent);
    return RlDatePickerPopupComponent;
}(RlDatePickerInputComponent));
export { RlDatePickerPopupComponent };
//# sourceMappingURL=datepicker-popup.component.js.map